import _Object$keys from 'babel-runtime/core-js/object/keys';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _Promise from 'babel-runtime/core-js/promise';
import _Object$assign from 'babel-runtime/core-js/object/assign';
import _regeneratorRuntime from 'babel-runtime/regenerator';

var normalizeConfig = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(ctx, obj) {
        var _this2 = this;

        var ret;
        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        // resolve accessors
                        if (typeof obj === 'function') obj = obj(ctx);
                        // resolve top-level promises
                        _context4.next = 3;
                        return obj;

                    case 3:
                        obj = _context4.sent;

                        // top-level default exports
                        if (typeof obj.default !== 'undefined') obj = obj.default;
                        // named components

                        if (!(typeof obj === 'string')) {
                            _context4.next = 7;
                            break;
                        }

                        return _context4.abrupt('return', obj);

                    case 7:
                        // anonymous components, may have promised values
                        ret = {};
                        _context4.next = 10;
                        return _Promise.all(_Object$keys(obj).map(function () {
                            var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(k) {
                                var v;
                                return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                                    while (1) {
                                        switch (_context3.prev = _context3.next) {
                                            case 0:
                                                _context3.next = 2;
                                                return obj[k];

                                            case 2:
                                                v = _context3.sent;

                                                // property default exports
                                                ret[k] = typeof v.default !== 'undefined' ? v.default : v;

                                            case 4:
                                            case 'end':
                                                return _context3.stop();
                                        }
                                    }
                                }, _callee3, _this2);
                            }));

                            return function (_x4) {
                                return _ref4.apply(this, arguments);
                            };
                        }()));

                    case 10:
                        return _context4.abrupt('return', ret);

                    case 11:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function normalizeConfig(_x2, _x3) {
        return _ref3.apply(this, arguments);
    };
}();
//# sourceMappingURL=index.js.map


import * as ko from 'knockout';
var UNINSTANTIABLE_VIEWMODEL_WARNING_ENABLED = true;
var uniqueComponentNames = /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var i;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    i = 0;

                case 1:
                    if (!true) {
                        _context.next = 6;
                        break;
                    }

                    _context.next = 4;
                    return '__router_view_' + i++ + '__';

                case 4:
                    _context.next = 1;
                    break;

                case 6:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, this);
})();
// @TODO (try to) make this type-safe, i.e. know it's void if routeConfig.component is void, and middleware if not
export function componentRoutePlugin(_ref) {
    var componentAccessor = _ref.component;

    if (!componentAccessor) return;
    return function (ctx) {
        var isNamedComponent = void 0;
        return {
            beforeRender: function beforeRender() {
                var _this = this;

                var _resolve = void 0;
                var resolveComponent = function resolveComponent(name, instance) {
                    var c = _Object$assign({ name: name }, instance || {});
                    ctx.route.component = name;
                    ctx.component = c;
                    _resolve(c);
                };
                var viewModelInstance = void 0;
                ctx.component = new _Promise(function (r) {
                    return _resolve = r;
                });
                ctx.queue(normalizeConfig(ctx, componentAccessor).then(function () {
                    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(normalizedConfig) {
                        var componentName, routedComponentInstance, templateConfig, viewModelConfig;
                        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                            while (1) {
                                switch (_context2.prev = _context2.next) {
                                    case 0:
                                        // named component
                                        if (typeof normalizedConfig === 'string') {
                                            isNamedComponent = true;
                                            resolveComponent(normalizedConfig);
                                            if (UNINSTANTIABLE_VIEWMODEL_WARNING_ENABLED) {
                                                // tslint:disable-next-line:no-console
                                                console.warn('[@profiscience/knockout-contrib-router-plugins-component] Unable to instantiate viewModel when using named components. This may cause unexpected behavior. View "Subtleties/Caveats" in the documentation.');
                                            }
                                        } else {
                                            // anonymous component
                                            componentName = normalizedConfig.name || uniqueComponentNames.next().value;
                                            routedComponentInstance = {
                                                name: componentName
                                            };
                                            templateConfig = normalizedConfig.template;
                                            viewModelConfig = void 0;

                                            if (normalizedConfig.viewModel) {
                                                try {
                                                    viewModelInstance = new normalizedConfig.viewModel(ctx);
                                                    viewModelConfig = { instance: viewModelInstance };
                                                    routedComponentInstance.viewModel = viewModelInstance;
                                                } catch (e) {
                                                    viewModelConfig = normalizedConfig.viewModel;
                                                    if (UNINSTANTIABLE_VIEWMODEL_WARNING_ENABLED) {
                                                        // tslint:disable-next-line:no-console
                                                        console.warn('[@profiscience/knockout-contrib-router-plugins-component] Unable to instantiate viewModel using `new`. This may cause unexpected behavior. See "Subtleties/Caveats" in the documentation.');
                                                    }
                                                }
                                            }
                                            resolveComponent(componentName, routedComponentInstance);
                                            ko.components.register(componentName, {
                                                synchronous: true,
                                                template: templateConfig,
                                                viewModel: viewModelConfig
                                            });
                                        }

                                    case 1:
                                    case 'end':
                                        return _context2.stop();
                                }
                            }
                        }, _callee2, _this);
                    }));

                    return function (_x) {
                        return _ref2.apply(this, arguments);
                    };
                }()));
            },
            afterRender: function afterRender() {
                if (!isNamedComponent) {
                    ko.components.unregister(ctx.route.component);
                }
            },
            beforeDispose: function beforeDispose() {
                if (!isNamedComponent && ctx.component) {
                    var c = ctx.component;
                    if (c.viewModel && c.viewModel.dispose) {
                        c.viewModel.dispose();
                        c.viewModel.dispose = function () {
                            /* noop */
                        };
                    }
                }
            }
        };
    };
}
export function disableUninstantiableViewModelWarning() {
    UNINSTANTIABLE_VIEWMODEL_WARNING_ENABLED = false;
}